/*
 * JBoss, Home of Professional Open Source
 * Copyright 2011 Red Hat Inc. and/or its affiliates and other contributors
 * as indicated by the @author tags. All rights reserved.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 */

package org.jboss.as.console.client.widgets.forms;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * @author Heiko Braun
 * @date 4/19/11
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD})
public @interface Binding {

    /**
     * The name of the detyped property
     * @return
     */
    String detypedName() default "";
    
    /**
     * If the type is a java.util.List, specify the fully-qualified name of the List type.
     * @return 
     */
    String listType() default "";

    /**
     * Shold be skipped?
     *
     * @return
     */
    boolean skip() default false;

    /**
     * Does act as a key?
     * @return
     */
    boolean key() default false;

    /**
     * Does support expressions?
     * @return
     */
    @Deprecated
    boolean expr() default true;

    /**
     * Should it be written as ModelType.UNDEFINED ?
     * If false this property will be ignored when writing changesets.
     */
    boolean writeUndefined() default true;
}
