/*
 * JBoss, Home of Professional Open Source
 * Copyright 2011 Red Hat Inc. and/or its affiliates and other contributors
 * as indicated by the @author tags. All rights reserved.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 */

package org.jboss.as.console.client.widgets.forms;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * @author Stan Silvert
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD})
public @interface FormItem {
    /**
     * Used for defaultValue.  Since annotations can not accept a value of null, use this String constant
     * to tell the PropertyBinding to set the default value to null.
     */
    public static final String NULL = "FormItem#undefined";
    
    String defaultValue() default "";

    String label() default "";

    @Deprecated
    String localLabel() default "";

    String tabName() default "";

    @Deprecated
    String localTabName() default "common_label_attributes";

    String subgroup() default "";

    int order() default 100;
    String[] acceptedValues() default {};
    boolean required() default false;
    String formItemTypeForEdit() default "TEXT_BOX";
    String formItemTypeForAdd() default "TEXT_BOX";

}
